unit MMJLinkEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,ShellApi;

type
  TEditType = (edNavigate, edMail, edICQ);
  TLanguage = (English, Croatian);
  TMouse=(Up,Down,Moving,None);
  TMMJLinkEdit = class(TEdit)
  private
    { Private declarations }
    FText : string;
    FSizeable:Boolean;
    FLanguage : TLanguage;
    FMouse:TMouse;
    FEditType : TEditType;
    FUrl : string;
    FMail : string;
    FICQ : string;
    FDoNavigate :Boolean;
    FDoMail :Boolean;
    FDoICQ: Boolean;
    FExit:Boolean;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseExit(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CMLButtonDown(var Message: TMessage); message wM_LBUTTONDOWN;
    procedure CMLBUTTONUP(var Message: TMessage); message wM_LBUTTONUP;
    procedure SetUrl(Value: string);
    procedure SetMail(Value: string);
    procedure SetICQ(Value: string);
    procedure SetEditType(Value :TEditType);
    procedure SetLanguage(Value :TLanguage);
    procedure NavigateTo (url : string; BPath: string);
    procedure SendMail (Address : string; BPath: string);
    procedure SetDoNavigate(Value:Boolean);
    procedure SetDoMail(Value:Boolean);
    procedure SetFSizeable(Value:Boolean);
    procedure SetDoICQ(Value:Boolean);
    function MeasureTextW(Txt : string):integer;
    function MeasureTextH(Txt : string):integer;
    procedure SrediHint(eType:TEditType; HasText:Boolean);
  protected
    { Protected declarations }
    procedure HandleEditExit(Sender :TObject);dynamic;
  public
    { Public declarations }
    procedure CreateParams(var Params: TCreateParams); override;
    constructor Create(AOwner :TComponent); override;

  published
    { Published declarations }
  property Url : string
     read FUrl
     write SetUrl;
  property Mail : string
     read FMail
     write SetMail;
  property ICQ : string
     read FICQ
     write SetICQ;
  property DoNavigate :Boolean
       read FDoNavigate
       write SetDoNavigate
       Stored True default False;
  property DoMail :Boolean
       read FDoMail
       write SetDoMail
       Stored True default False;
  property Sizeable :Boolean
       read FSizeAble
       write SetFSizeable
       Stored True default False;
  property DoICQ :Boolean
       read FDoICQ
       write SetDoICQ
       Stored True default False;
  property EditType :TEditType
       read FEditType
       write SetEditType;
  property Language :TLanguage
     read FLanguage
     write SetLanguage;
  end;

procedure Register;

implementation
var
   FValue :string;

procedure Register;
begin
  RegisterComponents('Samples', [TMMJLinkEdit]);
end;

procedure TMMJLinkEdit.SetUrl(Value: string);
 begin
    if FUrl <> Value then begin
       FUrl := Value;
    end;
 end;

procedure TMMJLinkEdit.SrediHint(eType:TEditType; HasText:Boolean);
begin
   //if HasText then HasText:=FExit;
   if eType= edNavigate then
      if Not FDoNavigate then
         HasText:=False;
   if eType= edMail then
      if Not FDoMail then
         HasText:=False;
   if eType= edICQ then
      if Not FDoICQ then
         HasText:=False;
         
   case eType of
      edNavigate:begin
                    if HasText then begin
                       if FLanguage=Croatian then
                          Hint:='Kliknite da posjetite Url: '+ Text;
                       if FLanguage=English then
                          Hint:='Clik to visit URL:' + Text;
                    end;
                    if not HasText then begin
                       if FLanguage=Croatian then
                          Hint:='Unesite Url osobe.';
                       if FLanguage=English then
                          Hint:='Insert Url'
                    end;
                 end;
      edMail: begin
                    if HasText then begin
                       if Flanguage=Croatian then
                          Hint:='Kliknite da poaljete mail: ' + Text;
                       if FLanguage=English then
                          Hint:='Clik to send mail to: '+ Text;
                    end;
                    if not HasText then begin
                       if FLanguage=Croatian then
                          Hint:='Unesite mail adresu';
                       if FLanguage=English then
                          Hint:='Insert e-mail address'
                    end;
                 end;
      edICQ: begin
                    if HasText then begin
                       if Flanguage=Croatian then
                          Hint:='Kliknite da PAGE-ate osobu: ' + Text;
                       if FLanguage=English then
                          Hint:='Clik to page: ' + Text;
                    end;
                    if not HasText then begin
                       if FLanguage=Croatian then
                          Hint:='Unesite ICQ broj';
                       if FLanguage=English then
                          Hint:='Insert ICQ UIN'
                    end;
                 end;
   end;
end;

procedure TMMJLinkEdit.SetDoNavigate(Value:Boolean);
begin
   if not (FEditType = edNavigate) then Exit;
   if FDoNavigate <> Value then begin
      FDoNavigate:=Value;
      FDoMail:=False;
      FDoICQ:=False;
   end;
end;

procedure TMMJLinkEdit.SetFSizeable(Value:Boolean);
begin
   if FSizeable <> Value then begin
      FSizeable:=Value;
   end;
end;

procedure TMMJLinkEdit.SetDoICQ(Value:Boolean);
begin
   if not (FEditType = edICQ) then Exit;
   if FDoICQ <> Value then begin
      FDoICQ:=Value;
      FDoMail:=False;
      FDoNavigate:=False;
   end;
end;

procedure TMMJLinkEdit.SetDoMail(Value:Boolean);
begin
   if not (FEditType = edMail) then Exit;
   if FDoMail <> Value then begin
      FDoMail:=Value;
      FDoICQ:=False;
      FDoNavigate:=False;
   end;
end;

procedure TMMJLinkEdit.SetICQ(Value: string);
 begin
    if FICQ <> Value then begin
       FICQ := Value;
    end;
 end;

procedure TMMJLinkEdit.SetMail(Value: string);
 begin
    if FMail <> Value then begin
       FMail := Value;
     end;
 end;

procedure TMMJLinkEdit.CreateParams(var Params: TCreateParams);
begin
   inherited CreateParams(Params);
   Params.Style:= Params.Style  or
     ES_RIGHT ;
   if FSizeable then
      Params.Style:= Params.Style or WS_SIZEBOX;
   if FEditType = edICQ then
      Params.Style:= Params.Style or ES_NUMBER;
end;

procedure TMMJLinkEdit.SetEditType(Value :TEditType);
begin
   if FEditType<> Value then begin
      FEditType:=Value;
   end;
end;

procedure TMMJLinkEdit.SetLanguage(Value :TLanguage);
begin
   if FLanguage<> Value then begin
      FLanguage:=Value;
   end;
end;

constructor TMMJLinkEdit.Create(AOwner:TComponent);
begin
   inherited Create(AOwner);
   FText:=Text;
   FExit:=False;
   FDoMail:=False;
   FDoNavigate:=False;
   FSizeable:=False;
   FDoICQ :=False;
   FUrl:='www.geocities.com/SiliconValley/Horizon/3229/index.html';
   FMail:='mihaela.mihaljevic-jakic@zg.tel.hr';
   FICQ:='9842704';
   with Font do begin
      Color:=clGreen;
      Style:=[fsUnderline,fsBold];
   end;
   FMouse:=None;
   OnExit:= HandleEditExit;
   AutoSize:=False;
   FEditType := edNavigate;
   ShowHint:=True;
end;


procedure TMMJLinkEdit.HandleEditExit(Sender :TObject);
var
   txt:string;
begin
   case FEditType of
      edNavigate: begin
                     if Text='' then Exit;
                     if Pos('http://',Text)= 0 then begin
                        Text:='http://' + Text;
                     end;
                     FUrl:=Text;
                     //FDoNavigate:=True;
                  end;
      edMail: begin
                     if Text='' then Exit;
                     if Pos('@',Text)= 0 then begin
                        txt:='Invalid mail address!';
                        if FLanguage=Croatian then
                           txt:='Neispravna mail adresa!';
                        ShowMessage(txt);
                        Text:='';
                        Exit;
                     end;
                     FMail:=Text;
                     //FDoMail:=True;
                  end;
      edICQ: begin
                     if Text='' then Exit;
                     FUrl:='http://wwp.mirabilis.com/' + Text;
                   //  FDoICQ:=True;
             end;
   end;
   //FExit:=True;
end;

procedure TMMJLinkEdit.NavigateTo (url : string; BPath: string);
   var
      ShowCmd: integer;
      txt : string;
begin
   ShowCmd:=sw_ShowMaximized;
   txt:='I can not lounch the browser' + #13 + 'because there isn t any!!';
   if FLanguage = Croatian then
      txt:='Ne mogu prokrenuti browser!';
   if not FileExists(BPath)then begin
      ShowMessage(txt);
      Exit;
   end;
   txt:='Couldn''t launch default browser:' + BPath;
   if FLanguage = Croatian then
      txt:= 'Ne mogu pokrenuti pretraiva: ' + BPath;
   if ShellExecute(application.handle,nil,pchar(BPath),pchar(FValue+' '+FUrl),nil,ShowCmd)<33 then
      raise Exception.create(txt);
end;


procedure TMMJLinkEdit.SendMail (Address : string; BPath: string);
   var
      ShowCmd: integer;
      FMailSubject:string;
      txt : string;
begin
   ShowCmd:=sw_ShowMaximized;
   FMailSubject:='No Subject';
   txt:='I can not lounch the browser' + #13 + 'because there isn t any!!';
   if FLanguage = Croatian then
      txt:='Ne mogu prokrenuti browser!';
   if not FileExists(BPath)then begin
      ShowMessage(txt);
      Exit;
   end;
   //Cheking the Address
   txt:='I can not send e-mail' + #13 + 'because there isn''t any address!!';
   if FLanguage = Croatian then
      txt:= 'Ne mogu poslati potu, jer nema adrese!';
   if pos('@',Address)=0 then begin
      ShowMessage(txt);
      Exit;
   end;
   //ShowMessage(url + #13 + BPath);
   //executing
   txt:='Couldn''t launch default browser:' + BPath;
   if FLanguage = Croatian then
      txt:= 'Ne mogu pokrenuti pretraiva: ' + BPath;
   if ShellExecute(application.handle,nil,pchar(BPath),pchar(FValue+' mailto:'+Address+'?subject='+FMailSubject),nil,ShowCmd)<33 then
      raise Exception.create(txt);
end;

function BrowserPath:string;
  var tmp:string;
      s,c:word;
  Value:string;
   function FindBrowser:string;
  var c:byte;
      hkey1,hkey2:hkey;
      typ,Ime:integer;
      tmp:array[0..1024] of char;
    const nbr_extension=4;
        extension:array[0..nbr_extension-1] of string=('.HTM','.HTML','.SHTML','.SHTM');
begin
  c:=0;
  repeat
    if regopenkeyex(hkey_classes_root,pchar(extension[c]),0,key_all_access,hkey1)=0 then
    begin
      if regqueryvalueex(hkey1,nil,nil,@typ,nil,@Ime)=error_success then
      begin
        regqueryvalueex(hkey1,nil,nil,nil,@tmp,@Ime);
        if tmp<>'' then
        if regopenkeyex(hkey_classes_root,pchar(tmp+'\shell\open\command'),0,key_all_access,hkey2)=error_success then
        begin
          if regqueryvalueex(hkey2,nil,nil,@typ,nil,@Ime)=error_success then
          begin
            regqueryvalueex(hkey2,nil,nil,nil,@tmp,@Ime);
            if tmp<>'' then
            begin
{              Arrange;}
              RegCloseKey(hkey2);
              FindBrowser:=strpas(tmp){tmpstr};
              Exit;
            end;
          end;
          regclosekey(hkey2);
        end;
        if regopenkeyex(hkey1,'shell\open\command',0,key_all_access,hkey2)=error_success then
        begin
          if regqueryvalueex(hkey2,nil,nil,@typ,nil,@Ime)=error_success then
          begin
            regqueryvalueex(hkey2,nil,nil,nil,@tmp,@Ime);
            if tmp<>'' then
            begin
{             Arrange;}
              RegCloseKey(hkey2);
              FindBrowser:=strpas(tmp){tmpstr};
              Exit;
            end;
          end;
        end;
      end;
      regclosekey(hkey1);
    end;
    inc(c);
  until c=nbr_extension;
  FindBrowser:='';
end;


begin
  tmp:=findbrowser;
  if tmp<>'' then
  begin
    c:=length(tmp)+1;
    repeat
      dec(c);
      Value:=uppercase(copy(tmp,c-3,4));
    until (Value='.EXE') or (Value='.BAT') or (Value='.COM');
    if c<length(tmp) then
    begin
      s:=c;
      Value:=trim(copy(tmp,c+1,length(tmp)-(c)));
      c:=1;
      while (c<=length(Value)) do
        if Value[c]='"' then delete(Value,c,1) else inc(c);
      if Value<>'' then
      begin
        c:=1;
        while c<=length(Value) do
        begin
          if Value[c]='%' then
          begin
            while (c<=length(Value)) and (Value[c]<>' ') do delete(Value,c,1);
          end else inc(c);
        end;
      end;
      Value:=trim(Value);
      delete(tmp,s+1,length(tmp)-s);
    end else Value:='';
    if tmp[1]='"' then delete(tmp,1,1);
  end;
  BrowserPath:=tmp;
  FValue:=Value;
end;


procedure TMMJLinkEdit.CMMouseEnter(var Message: TMessage);
  begin
    Cursor:=crHandPoint;
    FMouse:=moving;
    SrediHint(FEditType,Text<>'');
  end;

 procedure TMMJLinkEdit.CMMouseExit(var Message: TMessage);
  begin
    FMouse:=none;
  end;

procedure TMMJLinkEdit.CMLButtonDown(var Message: TMessage);
begin
   inherited;
   Cursor:=crHandPoint;
   FMouse:=Down;
end;

procedure TMMJLinkEdit.CMLButtonUP(var Message: TMessage);
begin
   inherited;
   if FMouse=Down then begin
      FMouse:=Up;
      Invalidate;
      FMouse:=none;
      if FDoNavigate then NavigateTo(FUrl,BrowserPath);
      if FDoMail then SendMail(FMail,BrowserPath);
      if FDoICQ then NavigateTo(FUrl,BrowserPath);
   end;

end;

function TMMJLinkEdit.MeasureTextW(Txt : string):integer;
var
   DC: HDC;
   Metrics: TTextMetric;
   Save: THandle;
   siz :TSize;
begin

   try
      DC := GetDC(0);
      Save := SelectObject(DC, Font.Handle);
      GetTextExtentPoint32(DC,PChar(Txt),Length(Txt),Siz);
   finally
      SelectObject(DC, Save);
      ReleaseDC(0, DC);
      DeleteObject(Save);
   end;
   result:=siz.cx;
end;

function TMMJLinkEdit.MeasureTextH(Txt : string):integer;
var
   DC: HDC;
   Metrics: TTextMetric;
   Save: THandle;
   siz :TSize;
begin

   try
      DC := GetDC(0);
      Save := SelectObject(DC, Font.Handle);
      GetTextExtentPoint32(DC,PChar(Txt),Length(Txt),Siz);
   finally
      SelectObject(DC, Save);
      ReleaseDC(0, DC);
      DeleteObject(Save);
   end;
   result:=siz.cy;
end;
end.
